import serial
import sqlite3
import re

# seriala pe portul COM5 cu baud rate 9600
ser = serial.Serial('COM5', 9600)

#ser.open()

# conectare la baza de date SQLite
conn = sqlite3.connect('uart.db')
c = conn.cursor()

# creare tabelă pentru a stoca datele
c.execute('''CREATE TABLE IF NOT EXISTS masuratori
             (temperatura REAL, data TIMESTAMP DEFAULT CURRENT_TIMESTAMP)''')

# procesare și salvare a datelor în tabelul bazei de date
i = 0
# variabilă de stocare a temperaturii precedente
previous_temp = None
while i < 100:
    line = ser.readline().decode('utf-8').rstrip()

    # verificare a formatului de mesaj cu temperatura
    if re.match(r'Temperature = \d+', line):
        temperatura = float(line.split(' = ')[1])
        c.execute("INSERT INTO masuratori (temperatura) VALUES (?)", (temperatura,))
        # SELECT din baza de date cu temperatura
        c.execute("SELECT * FROM masuratori WHERE temperatura = ?", (temperatura,))

        rows = c.fetchall()

        # verificare dacă s-a schimbat temperatura
        if temperatura != previous_temp:
            # afișare date
            for row in rows:
                temperatura = row[0]
                data = row[1]
                print(f"Temperatura: {temperatura} | Data: {data}")
            previous_temp = temperatura
        conn.commit()
        i = i + 1
    else:
        print("Invalid message format. Skipping...")
